clear
set more off

	if "`c(username)'" == "dwadhwa"{
		global path "C:/Users/dwadhwa/Dropbox/Charts/3 Doing Business/dbrank"
	}
	if "`c(username)'" == "Justin" {
		global path "/Users/Justin/Dropbox/Charts/3 Doing Business/dbrank"
	}	

local yr "06 07 08 09 10 11 12 13 14 15 16 17"

foreach i of local yr {

import excel "$path/input/DB`i'-FullReport.xlsx", sheet("PDFTables.com") clear

gen year = 20`i'


 if year == 2017 | year == 2016 {

	drop C D G H K L
	drop if B == "" | B == "Economy"
	rename A rank1
	rename B economy1
	rename E rank2
	rename F economy2
	rename I rank3
	rename J economy3
	
} 

else if year == 2015 | year == 2014 | year == 2013 {

	drop C F I
	drop if B == "" | B == "Economy"
	rename A rank1
	rename B economy1
	rename D rank2
	rename E economy2
	rename G rank3
	rename H economy3

	drop if economy2 == ""

}

else if year == 2012 | year == 2011 | year == 2010 {

	drop B D F H J L
	rename A rank1
	rename C economy1
	rename E rank2
	rename G economy2
	rename I rank3
	rename K economy3

	drop if economy2 == "" | economy2 == "ECONOMY" | economy2 == "Economy"

}

else if year == 2007 | year == 2009 {

	drop B E H
	drop if C == ""
	
	rename A rank1
	rename C economy1
	rename D rank2
	rename F economy2
	rename G rank3
	rename I economy3
	
	drop if economy2 == "Economy" | economy2 == "ECONOMY"
}

else if year == 2008 {

	drop if C == ""
	
	rename A rank1
	rename B economy1
	rename C rank2
	rename D economy2
	rename E rank3
	rename F economy3
	
	drop if economy2 == "" | economy2 == "Economy"

}

else if year == 2006 {
	
	rename A rank1
	rename B economy1
	rename C rank2
	rename D economy2
	rename E rank3
	rename F economy3
	rename G rank4
	rename H economy4
	
	drop if economy2 == "" | economy2 == "Economy"
	destring rank1, replace
	destring rank3, replace

}

	gen col = _n
	
	reshape long rank economy, i(col) j(type)
	
	drop col type
	destring rank, replace
	drop if rank == .
	
	kountryadd "Taiwan, China" to "Taiwan" add
	kountryadd "Côte d’Ivoire" to "Cote d'Ivoire" add
	kountryadd "FYR Macedonia" to "Macedonia" add
	kountryadd "Macedonia, former Yugoslav" to "Macedonia" add
	kountryadd "São Tomé and Principe" to "Sao Tome and Principe" add

	kountry economy, from(other) stuck
	rename _ISO3N_ numcode1
	kountry numcode1, from(iso3n) to(iso3c) m

	drop numcode1 NAMES_STD MARKER 
	rename _ISO3C_ isocode
	
	replace isocode = "TWN" if economy == "Taiwan, China"
	replace isocode = "KSV" if economy == "Kosovo"
	replace isocode = "SSD" if economy == "South Sudan"
	replace isocode = "MNE" if economy == "Montenegro"
	
save "$path/output/DB-20`i'.dta", replace

}
*

local yt "06 07 08 09 10 11 12 13 14 15 16"

foreach i of local yt {
mmerge economy year using "$path/output/DB-20`i'.dta", type(1:1)

}
*

drop _m

replace isocode = "TMP" if isocode == "TLS"
replace isocode = "ZAR" if isocode == "COD"
replace isocode = "WBG" if isocode == "PSE"
replace isocode = "ROM" if isocode == "ROU"
replace isocode = "CPV" if economy == "Cabo Verde"
replace isocode = "CIV" if economy == "Côte d’Ivoire"
replace isocode = "CIV" if economy == "Côte d'Ivoire"
replace isocode = "MKD" if economy == "FYR Macedonia"
replace isocode = "MKD" if economy == "Macedonia, former Yugoslav"
replace isocode = "HKG" if economy == "Hong Kong SAR, China"
replace isocode = "STP" if economy == "São Tomé and Principe"
replace isocode = "STP" if economy == "São Tomé and Príncipe"
replace isocode = "PRI" if economy == "Puerto Rico (U.S.)"


save "$path/output/dbranking.dta", replace


*****
collapse (first) economy , by(isocode)
gen startyr = 2006
gen endyr = 2017
gen length = endyr - startyr + 1

expand length
bysort economy: gen year = startyr + _n-1

mmerge isocode year using "$path/output/dbranking.dta", type(1:1)

save "$path/output/dbranking2.dta", replace

